package com.qmth.distributed.print.business.bean.dto;

import com.qmth.teachcloud.common.annotation.ExcelNote;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.constraints.NotNull;

/**
 * @Description: 课程知识点数据导入dto
 * @Author: CaoZixuan
 * @Date: 2024-02-27
 */
public class CourseDimensionDto {

    @ApiModelProperty("课程代码")
    @ExcelNote(value = "课程代码")
    @NotNull
    private String courseCode;

    @ApiModelProperty("课程名称")
    @ExcelNote(value = "课程名称")
    @NotNull
    private String courseName;

    @ApiModelProperty("一级属性内容")
    @ExcelNote(value = "一级属性内容")
    @NotNull
    private String firstDimensionName;

    @ApiModelProperty("二级属性内容")
    @ExcelNote(value = "二级属性内容")
    @NotNull
    private String secondDimensionName;

    public String getCourseCode() {
        return courseCode;
    }

    public void setCourseCode(String courseCode) {
        this.courseCode = courseCode;
    }

    public String getCourseName() {
        return courseName;
    }

    public void setCourseName(String courseName) {
        this.courseName = courseName;
    }

    public String getFirstDimensionName() {
        return firstDimensionName;
    }

    public void setFirstDimensionName(String firstDimensionName) {
        this.firstDimensionName = firstDimensionName;
    }

    public String getSecondDimensionName() {
        return secondDimensionName;
    }

    public void setSecondDimensionName(String secondDimensionName) {
        this.secondDimensionName = secondDimensionName;
    }
}
